﻿<?php
///////////////////////////////////////////////////////////////////////////
require_once 'utils.php';

class Cursor
{

	    private $m_feed;
	    private $m_feed_url;
	    private $m_items_count;
        private $m_last_ref;

    ///////////////////////////////////////////////////////////////////////

    public function __construct($media_url)
    {
        if ($media_url === 'main_menu:fav')
            $this->m_feed_url = 'main_menu:fav';
        else
            HD::decode_user_data($media_url, $media_str, $this->m_feed_url);

        $this->m_items_count = 0;
        $this->m_feed = 0;
        $this->m_last_ref = "";
    }

    private function parse_page($url)
    {	
        $api = HOST_API_URL;        
        $items = array();
        $doc = HD::http_get_document($url);
		$doc = str_replace('<![CDATA[','',$doc);
		$doc = str_replace(']]>','',$doc);
		//-//hd_print('--->>>1 --->>>' . $doc);
        if (preg_match("/stream_url/i",$doc)){
		$doc = str_replace("<stream_url>", "<playlist_url>", $doc);
		$doc = str_replace("</stream_url>", "</playlist_url>", $doc);
		}
		$videos = explode('<channel>', $doc);
        unset($videos[0]);
        $videos = array_values($videos);

        foreach($videos as $video)
        {	
            $tmp = explode('<playlist_url>', $video);
			if (count($tmp) < 2)
                continue;
            $season_ref = str_remove_spec(strstr($tmp[1], '</playlist_url>', true));
            
			$season_image = 'plugin_file://skins/logo.png';
			$tmp = explode('<img src="', $video);
			if (count($tmp) > 1)
			$season_image = str_remove_spec(strstr($tmp[1], '"', true));
            
			$s_desc = 'cScVOD';
			$tmp = explode('<description>', $video);
			if (count($tmp) > 1)
			$s_desc = strip_tags(str_remove_spec(strstr($tmp[1], '<description>', true)));
			
            $tmp = explode('<title>', $video);
			if (count($tmp) < 2)
                continue;
            $season_title = str_remove_spec(strstr($tmp[1], '</title>', true));
			$season_title = strip_tags($season_title);
			if (preg_match("/Предыдущая/i",$season_title) ||
			preg_match("/Следующая/i",$season_title) || 
			preg_match("/Назад/i",$season_title)|| 
			preg_match("/Плейлисты пользователя/i",$season_title)|| 
			preg_match("/В стартовый/i",$season_title))
			continue;
			$season_ref =  $season_ref . '&sinf&' . $season_title . '&sinf&' . $season_image . '&sinf&' . $s_desc;
			//-//hd_print("cursor--->>> season_ref: $season_ref");
            //-//hd_print("cursor--->>> season_title: $season_title");
            //-//hd_print("cursor--->>> season_image: $season_image");
            
            array_push
            (
                $items,
                HD::encode_user_data
                (
                    array
                    (
                        'video_id' => $season_ref,
                        'season_title' => $season_title,
                        'season_ref' => $season_ref,
                        'season_image' => $season_image,
                        'is_has_new' => false
                    )
                )
            );
            ++$this->m_items_count;
        }
        
        return $items;
    }
	
/////////////////////////////////////////////////////////////////
    private function parse_subcategory()
    {
        ////-//hd_print("--> parse subcategory: started...");
        $subcategory = $this->m_feed_url;
        $ref = $subcategory->subcategory_ref;
		////-//hd_print("--> ref...$ref");
       
        $url = $ref;
        ////-//hd_print("--> url1:$url");
        if ($this->m_feed > 0) {
        $tmp = explode('p=1', $ref);
		$url = $tmp[0] . 'p=' . ($this->m_feed + 1);
		////-//hd_print("--> url2:$url");
		}
        return $this->parse_page($url);
    }

    ///////////////////////////////////////////////////////////////////////
    private function parse_search_result($search)
    {
        //-//hd_print("--> parse search result: started... $search");
		$url = $search;
		if (!preg_match("/http:/i",$url)){
		$url = "http://93.188.161.204/php/poiskovik.php".$search;
		}
        if ($this->m_feed > 0) {
		if (preg_match("/p=1/i",$url))
		{$url_count = 'p=' . ($this->m_feed + 1);
		$url = str_replace("p=1", $url_count, $url);}
		else
		{return false;
		}}
		//-//hd_print("url--->>> search url: $url");
        return $this->parse_page($url);
    }
    ///////////////////////////////////////////////////////////////////////

    private function get_next_fav(&$plugin_cookies)
    {
        // ////-//hd_print("--> get favorites: started... $this->m_feed");
        
        $fav_items = isset($plugin_cookies->fav_items) ? $plugin_cookies->fav_items : '';
        
        $ref = "";
        
        $n = 0;
        foreach (ListUtil::string_to_list($fav_items) as $item)
        {
            if ($item == "")
                continue;
            
            if ($n == $this->m_feed)
            {
                $ref = $item;
            }

            ++$n;
            
        }

        if ($ref == "")
            return false;
        
        $items = array();

        $c = VideoCache::get($ref);
        if (!is_null($c))
        {
            array_push
            (
                $items,
                $c
            );

            ++$this->m_items_count;

            return $items;
            
        }

        $api = HOST_API_URL;
        
        $tmp = explode('&sinf&', $ref);
        $url = $tmp[0];
		$season_title = $tmp[1];
		$season_image = $tmp[2];
        
        array_push
        (
            $items,
            HD::encode_user_data
            (
                array
                (
                    'video_id' => $ref,
                    'season_title' => $season_title,
                    'season_ref' => $ref,
                    'season_image' => $season_image,
                    'is_has_new' => $is_has_new
                )
            )
        );

        ++$this->m_items_count;

        return $items;
    }
    ///////////////////////////////////////////////////////////////////////

    public function next_chunk($plugin_cookies)
    {
	    // ////-//hd_print("--> next_chunk(): started...");

	    $items = array();

        if ($this->m_feed_url === 'main_menu:fav')
        {
            // ////-//hd_print("--> parse favorites: started...");
            
            $items = $this->get_next_fav($plugin_cookies);
            ++$this->m_feed;

            if ($items === false)
                return false;
            
            return count($items) > 0 ? $items : false;
        }
	    if (HD::has_attribute($this->m_feed_url, 'ser_feed'))
	    {
		    // ////-//hd_print("--> search: started...");
            
		    $search_text = $this->m_feed_url->ser_feed;
            
            $items = $this->parse_search_result($search_text);
            ++$this->m_feed;
            
		    // ////-//hd_print("--> search for: " . $search_text);

            if ($items === false)
                return false;
                
            // ////-//hd_print("--> next_chunk(): found " . count($items) . " items.");
            return count($items) > 0 ? $items : false;
	    }
        else if (HD::has_attribute($this->m_feed_url, 'subcategory_ref'))
        {
           $items = $this->parse_subcategory();
            ++$this->m_feed;

            if ($items === false)
                return false;
                
            // ////-//hd_print("--> next_chunk(): found " . count($items) . " items.");
            return count($items) > 0 ? $items : false;
        }

        return false;
    }
}

///////////////////////////////////////////////////////////////////////////
?>
